{-
 *  Programmer:	Piotr Borek
 *  E-mail:     piotrborek@op.pl
 *  Copyright 2017 Piotr Borek
 *
 *  Distributed under the terms of the GPL (GNU Public License)
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
-}

module Simple.Locale.TranslateTH (
    tr,
    module Simple.Locale.Translate,
    module Data.Proxy
) where

import           Language.Haskell.TH
import           Language.Haskell.TH.Quote

import           Data.Proxy
import           Simple.Locale.Translate

tr :: QuasiQuoter
tr = QuasiQuoter
    { quoteExp  = translateTH
    , quotePat  = error "quotePat not supported"
    , quoteType = error "quoteType not supported"
    , quoteDec  = error "qutoteDec not supported"
    }

translateTH :: String -> Q Exp
translateTH s = return $
    AppE
        (VarE (mkName "Simple.Locale.TranslateTH.translate"))
        (SigE
            (ConE (mkName "Simple.Locale.TranslateTH.Proxy"))
            (AppT
                (ConT (mkName "Simple.Locale.TranslateTH.Proxy"))
                (LitT (StrTyLit s))
            )
        )
